var linebreak = 
{
	string: function()
	{
		var mac= /mac/i.test(navigator.platform);
		var win= /win/i.test(navigator.platform);
		var unix= /lin|unix|x11/i.test(navigator.platform);
		
		if (win)
			return "\r\n";
		else if (mac)
			return "\r";
		else
			return "\n";
	},
	
	length: function()
	{
		var win= /win/i.test(navigator.platform);
		
		return (win) ? 2 : 1;
	}
};

var BlockSitePrefs = 
{
	storePrefs: function()
	{
		const BlockSitePrefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("BlockSite.");
		
		// Store BlockSite.enabled
		BlockSitePrefBranch.setBoolPref("enabled", document.getElementById("blockSiteCheckbox").checked);
		// Store BlockSite.showWarning
		BlockSitePrefBranch.setBoolPref("showWarning", document.getElementById("blockSiteCheckboxWarning").checked);
		// Store BlockSite.removeLinks
		BlockSitePrefBranch.setBoolPref("removeLinks", document.getElementById("blockSiteCheckboxRemoveLinks").checked);
		// Store BlockSite.authenticate
		BlockSitePrefBranch.setBoolPref("authenticate", document.getElementById("blockSiteCheckboxAuthentication").checked);
		// Store BlockSite.password
		if(document.getElementById("blockSitePassword").value != "")
			BlockSitePrefBranch.setCharPref("password", hex_md5(document.getElementById("blockSitePassword").value));
		
		// Store BlockSite.listtype
		BlockSitePrefBranch.setCharPref("listtype", document.getElementById("listtypeRadiogroup").selectedItem.id);

		// Store BlockSite.locations
		var locationList = document.getElementById("BlockedWebsitesList");
		var locationCount = locationList.getRowCount();
		var locationArray = new Array();
		var locationNsIString = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
		for(var i=0; i < locationCount; i++)
		{
			locationArray.push(locationList.getItemAtIndex(i).label);
		}
		locationNsIString.data = locationArray.join("|||");
		BlockSitePrefBranch.setComplexValue("locations", Components.interfaces.nsISupportsString, locationNsIString);
	},
	
	readPrefs: function()
	{
		const BlockSitePrefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("BlockSite.");
	
		// Read BlockSite.enabled
		if(BlockSitePrefBranch.prefHasUserValue("enabled"))
		{
			document.getElementById("blockSiteCheckbox").checked = BlockSitePrefBranch.getBoolPref("enabled");
		}
		else
		{
			BlockSitePrefBranch.setBoolPref("enabled", true);
			document.getElementById("blockSiteCheckbox").checked = true;
		}
		
		// Read BlockSite.showWarning
		if(BlockSitePrefBranch.prefHasUserValue("showWarning"))
		{
			document.getElementById("blockSiteCheckboxWarning").checked = BlockSitePrefBranch.getBoolPref("showWarning");
		}
		else
		{
			BlockSitePrefBranch.setBoolPref("showWarning", true);
			document.getElementById("blockSiteCheckboxWarning").checked = true;
		}
		
		
		// Read BlockSite.removeLinks
		if(BlockSitePrefBranch.prefHasUserValue("removeLinks"))
		{
			document.getElementById("blockSiteCheckboxRemoveLinks").checked = BlockSitePrefBranch.getBoolPref("removeLinks");
		}
		else
		{
			BlockSitePrefBranch.setBoolPref("removeLinks", true);
			document.getElementById("blockSiteCheckboxRemoveLinks").checked = true;
		}


		// Read BlockSite.authenticate
		if(BlockSitePrefBranch.prefHasUserValue("authenticate"))
		{
			document.getElementById("blockSiteCheckboxAuthentication").checked = BlockSitePrefBranch.getBoolPref("authenticate");
		}
		else
		{
			BlockSitePrefBranch.setBoolPref("authenticate", false);
			document.getElementById("blockSiteCheckboxAuthentication").checked = false;
		}

		// Read BlockSite.listtype
		if(!BlockSitePrefBranch.prefHasUserValue("listtype"))
		{
			BlockSitePrefBranch.setCharPref("listtype", "blacklistRadio");
		}
		document.getElementById("listtypeRadiogroup").selectedItem = document.getElementById(BlockSitePrefBranch.getCharPref("listtype"));
		this.changeListType();

		// Read BlockSite.locations
		var blockedWebsitesString = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	
		if(BlockSitePrefBranch.prefHasUserValue("locations"))
		{
			blockedWebsitesString = BlockSitePrefBranch.getComplexValue("locations", Components.interfaces.nsISupportsString).data;
			var blockedWebsitesArray = blockedWebsitesString.split("|||");
		}
		else
		{
			var blockedWebsitesArray = new Array();
		}
		
		var locationList = document.getElementById("BlockedWebsitesList");
		
		for(var i=0; i < blockedWebsitesArray.length; i++)
		{
			if(blockedWebsitesArray[i] != "")
			{
				locationList.appendItem(blockedWebsitesArray[i]);
			}
		}
	},
	
	changeListType: function()
	{
		document.getElementById("listtypeCaption").label = document.getElementById("listtypeRadiogroup").selectedItem.label;
	},
	
	editLocation: function()
	{
		var locationList = window.opener.document.getElementById('BlockedWebsitesList');
		var selectedLocation = locationList.getSelectedItem(0);
		
		var locationTextbox = document.getElementById('blockSiteLocation');
		locationTextbox.value = selectedLocation.label;
	},
	
	updateLocation: function()
	{
		var locationList = window.opener.document.getElementById('BlockedWebsitesList');
		var selectedLocation = locationList.getSelectedItem(0);
		
		var locationTextbox = document.getElementById('blockSiteLocation');
		selectedLocation.label = locationTextbox.value;
	},
	
	addLocation: function()
	{
		var locationList = window.opener.document.getElementById("BlockedWebsitesList");
		
		var newLocation = document.getElementById("blockSiteNewLocation").value
		if(newLocation)
			locationList.appendItem(newLocation);
	},
	
	removeLocation: function()
	{
		var locationList = document.getElementById("BlockedWebsitesList");
		
		locationList.removeItemAt(locationList.selectedIndex);
	},
	
	removeAllLocations: function()
	{
		var locationList = document.getElementById("BlockedWebsitesList");
		
		while(locationList.getRowCount())
		{
			locationList.removeItemAt(0);
		}
	},
	
	importList: function()
	{
		var filePickerImport = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		var streamImport = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
		var streamIO = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
		var overwriteCurrentList = false;
		var input;
		var inputArray;
		var validFile = false;
		
		filePickerImport.init(window, "Select a File", filePickerImport.modeOpen);
		filePickerImport.appendFilters(filePickerImport.filterText);

		if(filePickerImport.show() != filePickerImport.returnCancel)
		{
			streamImport.init(filePickerImport.file, 0x01, 0444, null);
			streamIO.init(streamImport);
			input = streamIO.read(streamImport.available());
			streamIO.close();
			streamImport.close();
			
			// now: unix + mac + dos environment-compatible
			linebreakImport = input.match(/(?:\[Block[Ss]ite\])(((\n+)|(\r+))+)/m)[1]; // first: whole match -- second: backref-1 -- etc..
			inputArray = input.split(linebreakImport);
			
			var headerRe = /\[Block[Ss]ite\]/; // tests if the first line is BlockSite's header
			if (headerRe.test(inputArray[0])) 
			{
				inputArray.shift();
				var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService); 
				var msg = "Do you want to Replace your current locations?\n..or Append to them?", title = "BlockSite Import", appendLabel = "Append", replaceLabel = "Replace", cancelLabel="Cancel Import"; 
				var flags = promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_2 + promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1 + promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 + (promptService.BUTTON_POS_0_DEFAULT?promptService.BUTTON_POS_0_DEFAULT:0); 
				var buttonPressed = promptService.confirmEx(window,title,msg,flags,cancelLabel,replaceLabel,appendLabel,null,{});
				if (buttonPressed == 0) return; // second confirm -- user cancelled.
				var shouldAppend = (buttonPressed == 2);
				
				if(!shouldAppend)
				{
					BlockSitePrefs.removeAllLocations();
				}
				
				for(var i=0; i<inputArray.length; i++)
				{
					var locationList = document.getElementById("BlockedWebsitesList");
					
					if(inputArray[i])
						locationList.appendItem(inputArray[i]);
				}
			}
		}
	},
	
	exportList: function()
	{
		var filepickerExport = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		var exportStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

		filepickerExport.init(window, "Select a File", filepickerExport.modeSave);
		filepickerExport.defaultExtension=".txt";
		filepickerExport.appendFilters(filepickerExport.filterText);

		if (filepickerExport.show() != filepickerExport.returnCancel) {
			if (filepickerExport.file.exists())
				filepickerExport.file.remove(true);
			filepickerExport.file.create(filepickerExport.file.NORMAL_FILE_TYPE, 0666);

			exportStream.init(filepickerExport.file, 0x02, 0x200, null);
			exportStream.write("[BlockSite]" + linebreak.string(), 11 + linebreak.length());
			
			var locationList = document.getElementById("BlockedWebsitesList");
			var locationCount = locationList.getRowCount();
			
			for(var i=0; i<locationCount; i++)
			{
				var location = locationList.getItemAtIndex(i).label;
				exportStream.write(location, location.length);
				exportStream.write(linebreak.string(), linebreak.length());
			}
			
			exportStream.close();
		}
	}
}
